package gp_dbc.items;

import cpw.mods.fml.common.registry.GameRegistry;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import gp_dbc.Main;
import gp_dbc.config.ConfigManager;
import gp_dbc.utils.Data;
import gp_dbc.utils.RayTrace;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.*;
import net.minecraft.world.World;

import java.util.List;

public class ItemJailManager extends Item {

    public ItemJailManager()
    {
        super();
        setUnlocalizedName(Main.MODID +".jail_manager");
        GameRegistry.registerItem(this, getUnlocalizedName());
        setCreativeTab(Main.tabGP);
        setTextureName(Main.MODID + ":jail_manager");
        setMaxStackSize(1);
    }

    @Override
    @SideOnly(Side.SERVER)
    public ItemStack onItemRightClick(ItemStack itemStack, World world, EntityPlayer player) {
        if (player.isSneaking()) {
            MovingObjectPosition trace = RayTrace.rayTraceServer(player, 5);
            if (trace != null && trace.typeOfHit == MovingObjectPosition.MovingObjectType.BLOCK) {
                player.addChatMessage(new ChatComponentText(EnumChatFormatting.YELLOW + "x: " + trace.blockX + " y: " + trace.blockY + " z: " + trace.blockZ));
                if (Main.gp.jail.addCell(trace.blockX, trace.blockY, trace.blockZ, player.dimension))
                    player.addChatMessage(new ChatComponentText(EnumChatFormatting.GREEN + ConfigManager.SUCCESS_ADD_CELL));
                else
                    player.addChatMessage(new ChatComponentText(EnumChatFormatting.RED + ConfigManager.ERROR_ADD_CELL));
            }
        }
        else { }
            // gui manage jail cells

        return itemStack;
    }

    @SideOnly(Side.CLIENT)
    public void addInformation(ItemStack par1ItemStack, EntityPlayer par2EntityPlayer, List par3List, boolean par4) {
        par3List.add("Sneaking Right Click to place a jail cell");
        par3List.add("Right Click to manage jail cells");
    }
}
