package gp_dbc.system;

import JinRyuu.JRMCore.server.JGPlayerMP;
import cpw.mods.fml.common.eventhandler.SubscribeEvent;
import cpw.mods.fml.common.gameevent.TickEvent;
import gp_dbc.utils.Data;
import gp_dbc.config.ConfigManager;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.util.ChatComponentText;
import net.minecraft.util.EnumChatFormatting;

import java.util.List;
import java.util.UUID;

public class GalacticPatrol {

    private List<UUID> patrolmans;
    public Jail jail;

    public GalacticPatrol() {
        patrolmans = Data.loadDataUUID("galactic_patrols");
        jail = new Jail();
    }

    public int addToGalaticPatrol(EntityPlayer player) {
        return addToGalaticPatrol(player, false);
    }

    public int addToGalaticPatrol(EntityPlayer player, boolean chatError) {
        return addToGalaticPatrol((EntityPlayerMP)player, chatError);
    }

    public int addToGalaticPatrol(EntityPlayerMP player) {
        return addToGalaticPatrol(player, false);
    }

    public int addToGalaticPatrol(EntityPlayerMP player, boolean chatError) {

        JGPlayerMP jgPlayer = new JGPlayerMP(player);
        jgPlayer.connectBaseNBT();
        int align = jgPlayer.getAlignment();


        if (align < ConfigManager.MIN_ALIGN_TO_JOIN) {
            if (chatError)
                player.addChatMessage(new ChatComponentText(EnumChatFormatting.RED + ConfigManager.ERROR_MIN_ALIGN_TO_JOIN));
            return 2;
        }
        else if (align > ConfigManager.MAX_ALIGN_TO_JOIN) {
            if (chatError)
                player.addChatMessage(new ChatComponentText(EnumChatFormatting.RED + ConfigManager.ERROR_MAX_ALIGN_TO_JOIN));
            return 3;
        }

        if (!patrolmans.contains(player.getUniqueID())) {
            patrolmans.add(player.getUniqueID());
            player.addChatMessage(new ChatComponentText(EnumChatFormatting.GREEN + ConfigManager.SUCCESS_JOIN_GALACTIC_PATROL));
        }
        else
            player.addChatMessage(new ChatComponentText(EnumChatFormatting.RED + ConfigManager.ERROR_JOIN_GALACTIC_PATROL));

        Data.saveDataUUID(patrolmans, "galactic_patrols");

        return 0;
    }

    private void addForceToGalacticPatrol(UUID uuid) {
        patrolmans.add(uuid);
        Data.saveDataUUID(patrolmans, "galactic_patrols");
    }

    public boolean removeFromGalaticPatrol(EntityPlayer player) {
        return removeFromGalaticPatrol(player, false);
    }

    public boolean removeFromGalaticPatrol(EntityPlayer player, boolean chatError) {
        return removeFromGalaticPatrol((EntityPlayerMP)player, chatError);
    }

    public boolean removeFromGalaticPatrol(EntityPlayerMP player) {
        return removeFromGalaticPatrol(player, false);
    }

    public boolean removeFromGalaticPatrol(EntityPlayerMP player, boolean chatError) {

        boolean removed = patrolmans.remove(player.getUniqueID());
        Data.saveDataUUID(patrolmans, "galactic_patrols");

        if (removed)
            player.addChatMessage(new ChatComponentText(EnumChatFormatting.GREEN + ConfigManager.SUCCESS_LEAVE_GALACTIC_PATROL));
        else
            player.addChatMessage(new ChatComponentText(EnumChatFormatting.RED + ConfigManager.ERROR_LEAVE_GALACTIC_PATROL));

        return removed;
    }

    public boolean isInGalacticPatrol(EntityPlayer player) {
        return patrolmans.contains(player.getUniqueID());
    }

    public boolean isInGalacticPatrol(EntityPlayerMP player) {
        return patrolmans.contains(player.getUniqueID());
    }

    public boolean isInGalacticPatrol(UUID uuid) {
        return patrolmans.contains(uuid);
    }

    public List<UUID> getPatrolmans() { return patrolmans; }
}
