package gp_dbc.system;

import java.util.UUID;

public class Inmate {

    private long secInJail;
    private long timeStartJail;
    private UUID uuid;
    private Cell cell;

    public Inmate(UUID uuid) {
        this(null, uuid, 0, 0);
    }

    public Inmate(Cell cell, UUID uuid, long secInJail) {
        this(cell, uuid, secInJail, secInJail);
    }

    public Inmate(Cell cell, UUID uuid, long secInJail, long secInJailLeft) {
        this.cell = cell;
        this.uuid = uuid;
        this.secInJail = secInJail;
        this.timeStartJail = System.currentTimeMillis();

        if (cell != null)
            cell.addJailer(this);
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;

        if (!(obj instanceof Inmate))
            return false;

        Inmate objInmate = (Inmate)obj;
        return uuid.equals(objInmate.getUuid());
    }

    public boolean equals(UUID uuid) {
        return this.getUuid().equals(uuid);
    }

    public long getSecInJail() { return secInJail; }
    public long getTimeStartJail() { return timeStartJail; }
    public UUID getUuid() { return uuid; }
    public Cell getCell() { return cell; }

}

